<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Trees</TITLE>
<link href="suif1_11.html" rel=Next>
<link href="suif1_9.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_9.html">previous</A>, <A HREF="suif1_11.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC10" HREF="suif1_toc.html#TOC10">Abstract Syntax Trees</A></H1>
<P>
<A NAME="IDX21"></A>
<A NAME="IDX22"></A>
<A NAME="IDX23"></A>

</P>
<P>
Procedure bodies are represented using a language-independent form of
abstract syntax trees (ASTs).  In high-SUIF code, the trees contain
nodes corresponding to the high-level control structures in the source
program.  When the code is expanded to the low-SUIF form, these
high-level constructs are replaced and the trees degenerate to lists of
instructions.

</P>
<P>
SUIF is not restricted to handling programs with structured control
flow.  Even in high-SUIF code, low-level branch and jump instructions
may be used to represent unstructured control flow.  However, since most
high-level transformations are only applied to structured code, the
high-level AST nodes are only used for structured code.  This makes it
easy to identify and optimize regions of code with structured control
flow.

</P>
<P>
The files <TT>`trees.h'</TT> and <TT>`trees.cc'</TT> contain the code for tree
nodes and tree node lists.

</P>

<UL>
<LI><A HREF="suif1_11.html#SEC11">Tree Nodes</A>: Basic tree objects.
<LI><A HREF="suif1_20.html#SEC20">Tree Node Lists</A>: Lists of tree nodes.
<LI><A HREF="suif1_21.html#SEC21">Mapping Subtrees</A>: Applying functions to nodes in a subtree.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_9.html">previous</A>, <A HREF="suif1_11.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
